#include <vector>
#include <iostream>
#include "Simplex.hpp"
#include "BranchAndBound.hpp"

using namespace std;
void print(const std::vector<std::vector<double> >& matrix) {
	for(unsigned i = 0; i < matrix.at(0).size(); ++i) {
		for(unsigned j = 0; j < matrix.size(); ++j) {
			std::cout << matrix.at(j).at(i) << " ";
		}
		std::cout << std::endl;
	}
	std::cout << std::endl;
}

int main()
{
//	double aCosts[5] = {7,1,5,0,0};
//	double aConstraints[5][2] = {{1,5},{-1,2},{3,-1},{-1,0}, {0,-1}};
//	double aRhs[2] = {10,6};

	double aCosts[7] = {1,2,3,6,3, 0,0};
	double aConstraints[7][4] = {{-.05,0,4,0},{0,-1,0,2.5},{1,-1,0,1},{-1,5,0,0}, {0,2,-2,0},{1,0,5,0},{0,-1,0,0}};
	double aRhs[5] = {-2,1,2, 2};

	vector<double> costs(aCosts, aCosts+7);
	vector<double> rhs(aRhs, aRhs+4);
	vector<vector<double> > constraints;
	for(int i = 0; i < 7; ++i )
		constraints.push_back(vector<double>(aConstraints[i], static_cast<double*>(aConstraints[i]+4)));

	Simplex s(constraints, costs, rhs);

	for(int i =0; i < 7; ++i) {
		s.addLEConstraint(i,50);
	}

	bool integer[7] = {true, true, true, true, true, true, true};
	vector<bool> passInt(integer, integer+7);
	BranchAndBound b(s, passInt);
	b.solve();
	cout << b.currentObjective() << endl;
}
